document.addEventListener("deviceready", onDeviceReady, false);


var Launched = false;
// PhoneGap is loaded and it is now safe to make calls PhoneGap methods
function onDeviceReady() {
	PageLoad();
}

/*if on desktop comment out when publishing for live file
*/
$(function() {
  PageLoad();
});

function PageLoad(){
	//only run this once
	if(!Launched){
	
		// Now safe to use the PhoneGap API
		if(window.location.pathname.indexOf('index.html') > 0){
			indexPageLoad();
		}else if(window.location.pathname.indexOf('edit.html') > 0){
			editPageLoad();
		}else if(window.location.pathname.indexOf('view.html') > 0){
			viewPageLoad();
		}else if(window.location.pathname.indexOf('addmatch.html') > 0){
			addmatchPageLoad();
		}else if(window.location.pathname.indexOf('scorematch.html') > 0){
			scorematchPageLoad();
		}	
	
		Launched= true;
	}

}

function indexPageLoad(){
	//did we save successfully
	if(window.location.pathname.indexOf('index.html') > 0){

		//Load this out of local storage/ SQL Implementation !!!
		var data = GetObjectFromLocalStorage("Matches");

		$('.list').append(ich.matches(data));

		//Setup onclick for rows
		$(".FirstBoxer, .SecondBoxer").click(function(e) {
			var MatchId = $(this).attr('id').substring(4);

			SetMatchId(MatchId);
			document.location.href = "view.html";
		});

		$(".FirstBoxer .edit a, .SecondBoxer .edit a").click(function(e){
			e.stopPropagation()

			var MatchId = $(this).closest('tr').attr('id').substring(4);
			SetMatchId(MatchId);
			document.location.href = "scorematch.html";
		});

		//Setup onclick for delete match
		$("td.remove .cancel").click(function(e) {
			e.stopPropagation();
			
			SetMatchId($(this).attr('bscid'));
			
			
			navigator.notification.confirm(
		        'Are you sure you wish to delete this match?',  // message
		        RemoveMatch,              // callback to invoke with index of button pressed
		        'Confirm Delete',            // title
		        'OK,Cancel'          // buttonLabels
		    );
			
			
			
		});
		

		$(".FirstBoxer, .SecondBoxer").mouseenter(function() {
			var MatchId = $(this).attr('id').substring(4);

	  		$('#SBM_' + MatchId).addClass('rowHover');
	  		$('#FBM_' + MatchId).addClass('rowHover');
		});

		$(".FirstBoxer, .SecondBoxer").mouseleave(function() {
			var MatchId = $(this).attr('id').substring(4);

	  		$('#SBM_' + MatchId).removeClass('rowHover');
	  		$('#FBM_' + MatchId).removeClass('rowHover');
		});
    }
}

function editPageLoad(){
	alert('Edit match - ' + GetMatchId());
}

function viewPageLoad(){
	var objMatch = GetCurrentMatchObject();
	$('#matchSummary').append(ich.tmpmatchSummary(objMatch));

	var rounds = GetObjectFromLocalStorage("Match_" + objMatch.matchid);

	var data ={};
	data.round = rounds.round;
	data.firstboxertotalscore = objMatch.firstboxerscore;
	data.secondboxertotalscore = objMatch.secondboxerscore;

	$('#matchRounds').append(ich.tmpmatchRounds(data));
}

function addmatchPageLoad(){

	$('#MatchDate').val(GetDateDDMMYYYY());
}

function scorematchPageLoad(){
	
	var objMatch = GetCurrentMatchObject();
	$('#matchSummary').append(ich.tmpmatchSummary(objMatch));

	var rounds = GetCurrentMatchRounds();
	$('#matchRounds').append(ich.tmpmatchRounds(rounds));

}

function testcallback(){
	//could do something here
}


/*Add Match functions*/
function SaveNewMatch(){
	var d=new Date();

	//will get a Integer we can use for the matchId!
	var MatchId= d.valueOf();

	var match = {};
	match.firstboxername = $('#BoxerOneName').val();
	match.secondboxername = $('#BoxerTwoName').val();
	match.matchid = MatchId;
	match.firstboxerscore = "-";
	match.secondboxerscore = "-";
	
	match.rounds= $('#Rounds').val();
	match.matchdate= $('#MatchDate').val();

	//ensure we stringify before setting into local storage!
	AddMatchToLocalStorage(match);

	SetMatchId(MatchId);

	//If successful then redirect to homepage! (will in future redirect to scoring page!)
	document.location.href = "scorematch.html";
}

function SaveScores(){
	//get the match object - Will be updating this with new scores
	var match = GetCurrentMatchObject();

	//build the rounds to save
	var MatchRounds = { "round" : [] };

	//count boxer A and B Scores
	var FirstBoxerMatchScore = 0;
	var SecondBoxerMatchScore = 0;

	//for each round we have against match
	for(var i = 1; i <= match.rounds; i++){
		//get the scores for this match
		var FirstBoxerRoundScore = $('#A' + i).val();
		var SecondBoxerRoundScore =  $('#B' + i).val();

		//create round with scores
		var objRound = {};
		objRound.round = i;
		objRound.firstboxerscore = parseInt(FirstBoxerRoundScore);
		objRound.secondboxerscore = parseInt(SecondBoxerRoundScore);
		MatchRounds.round.push(objRound);

		//total up score A and B as we go along!
		FirstBoxerMatchScore += parseInt(FirstBoxerRoundScore);
		SecondBoxerMatchScore += parseInt(SecondBoxerRoundScore);
	}

	
	//save match rounds back into session
	SaveAllMatchRounds(MatchRounds, match.matchid);

	//Update the current match object with total score
	match.firstboxerscore = FirstBoxerMatchScore;
	match.secondboxerscore = SecondBoxerMatchScore;

	//Save back into storage
	SaveMatch(match);

	//redirect
	document.location.href = 'index.html';
}

function toggleDeleteMode(){
	
	navigator.notification.vibrate(200);

	$('td.remove').toggle();
	$('td.edit').toggle();
	$('#editMode').toggleClass('selected');
}

/*EXTRAS HELPER FUNCTIONS*/
$.extend({
  getUrlVars: function(){
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
      hash = hashes[i].split('=');
      vars.push(hash[0]);
      vars[hash[0]] = hash[1];
    }
    return vars;
  },
  getUrlVar: function(name){
    return $.getUrlVars()[name];
  }
});

function GetDateDDMMYYYY(){
	var d = new Date();
	var curr_date = d.getDate();
	var curr_month = d.getMonth();
	var curr_year = d.getFullYear();
	return pad2(curr_date) + "/" + pad2(curr_month) + "/" + curr_year;
}

function pad2(number) {
    return (number < 10 ? '0' : '') + number;
}

function AddMatchToLocalStorage(match){
	var data = { "matches": [] };

	//if we are not new we want to get our matches from local storage
	if(window.localStorage.getItem("Matches") !== null){
		
		//get our matches as a object!
		data = GetObjectFromLocalStorage("Matches");

		if (!data.hasOwnProperty('matches')) { 
			//something went wrong... we are overwriting it all
			alert('Something went wrong. data is being cleared');
			data = { "matches": [] };
		}
	}

	//add the match to the array
	data.matches.push(match);

	//save match to local storage
	SaveAllMatches(data);  
}

function RemoveMatch(button){

	if(button === 1){
		var matchId = GetMatchId();
		
		RemoveMatchFromLocalStorage(matchId);
		
		$('#FBM_' + matchId).addClass('deleteHighlight').fadeOut(500, function() {
			$(this).remove();
		}); 
		$('#SBM_' + matchId).addClass('deleteHighlight').fadeOut(500, function() {
			$(this).remove();
		});	
	}

}

function RemoveMatchFromLocalStorage(matchId){
	var CurrentMatchid = matchId;
	var data = GetObjectFromLocalStorage("Matches");
	var matchPosition = -1;

	//loop each object and see if it matches
	var i=0;
	for(i=0; i< data.matches.length; i++){
		var match = data.matches[i];
		if(match.matchid == CurrentMatchid){
			matchPosition = i;
		}
	}
	var NewData = data.matches.splice(matchPosition, 1);

	SaveAllMatches(data);

	//and clear the match rounds against this matchId!
}

function GetObjectFromLocalStorage(key){
	return JSON.parse(window.localStorage.getItem(key));
}

function SaveMatch(match){
	var data = GetObjectFromLocalStorage("Matches");

	for(var i = 0; i< data.matches.length; i++){

		if(match.matchid == data.matches[i].matchid){

			data.matches[i] = match;
			break;
		}
	}

	SaveAllMatches(data);
}

function SaveAllMatches(data){
	var jsonString = JSON.stringify(data); 
	window.localStorage.setItem("Matches", jsonString);
}

function SaveAllMatchRounds(data, matchid){
	var jsonString = JSON.stringify(data); 
	window.localStorage.setItem("Match_" + matchid, jsonString);
}


function SetMatchId(matchid){
	window.localStorage.setItem("MatchId", matchid);
}

function GetMatchId(){
	return window.localStorage.getItem("MatchId");
}

function GetCurrentMatchObject(){
	var CurrentMatchid = GetMatchId();
	var data = GetObjectFromLocalStorage("Matches");

	for(var i = 0; i< data.matches.length; i++){
		var match = data.matches[i];
		if(match.matchid == CurrentMatchid){
			return match;
		}
	}

	return null;
}


function GetCurrentMatchRounds(){
	var matchid = GetMatchId();
	var match = GetCurrentMatchObject();

	var MatchRounds = GetObjectFromLocalStorage("Match_" + matchid);

	var obj = { "Round": []};
	if(MatchRounds === null){

	    for(var i = 1; i <= match.rounds; i++)
		{
			var objRound = {};
			objRound.id = i;
			objRound.A = CreateDDL(-1);
			objRound.B = CreateDDL(-1);
			obj.Round.push(objRound);
		}

		
	}else{
	    for(var i = 1; i <= match.rounds; i++)
		{
			//build the dropdownlists based on the roudns we have and the scores !
			//will need to handle have safed matches with only 3 of 12 round saved???
			var objRound = {};
			objRound.id = i;
			objRound.A = CreateDDL(MatchRounds.round[i-1].firstboxerscore);
			objRound.B = CreateDDL(MatchRounds.round[i-1].secondboxerscore);
			obj.Round.push(objRound);

		}
	}
	return obj;
}

function CreateDDL(SelectedValue){
	var ddl = [];

	//
	var objScore = {};
	objScore.Value = 0;
	objScore.Text = "Select...";
	if(SelectedValue === 0){
		objScore.Selected = true;
	}
	ddl.push(objScore);

	for(var i = 10; i >= 1; i--)
	{
		var objScore = {};
		objScore.Value = i;
		objScore.Text = i;
		if(SelectedValue === i){
			objScore.Selected = true;
		}
		ddl.push(objScore);
	}
	return ddl;

}
